Bug 825414 - Review Request: flexiport - Flexible communications library
Review Request: flexiport - Flexible communications library
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Dan Callaghan
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-05-25 22:33 EDT by Rich Mattes
Modified: 2012-09-02 14:14 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-09-02 14:14:59 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
dcallagh: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Rich Mattes 2012-05-25 22:33:57 EDT
Spec URL: http://rmattes.fedorapeople.org/RPMS/flexiport/flexiport.spec
SRPM URL: http://rmattes.fedorapeople.org/RPMS/flexiport/flexiport-2.0.0-1.20111231git.fc17.x86_64.rpm

Description: 
Flexiport provides a consistent interface for communicating over a range of
data port types. Currently serial (including serial-over-USB), TCP and UDP
ports are supported. Logging is supported which allows communications sessions
to be played back at a later date without the original hardware present.

Fedora Account System Username: rmattes

rpmlint:

$ rpmlint flexiport.spec ../RPMS/x86_64/flexiport-*
flexiport.spec: W: invalid-url Source0: flexiport-2.0.0.tar.bz2
3 packages and 1 specfiles checked; 0 errors, 1 warnings.

This is OK, the tarball is a git snapshot, and instructions for duplicating it are in the spec file comments.

Flexiport is currently included in the "gearbox" package, but the latest upstream release of gearbox made a shift from GPL to the Eclipse public license.  The copyright holder of flexiport re-licensed the flexiport library separately under the LGPL and is hosting it separately on github.  The GPL licensed Player package can't be distributed when built against an Eclipse licensed gearbox, but it can when built against the LGPL-licensed flexiport.  

Once this package is accepted, I will upgrade gearbox to the latest upstream eclipse licensed release(10.04), make the flexiport package conflict with earlier versions (<= 9.11), and submit flexiport to the stable repos.
Comment 1 Jiri Popelka 2012-06-29 08:54:28 EDT
(In reply to comment #0)
> SRPM URL:
> http://rmattes.fedorapeople.org/RPMS/flexiport/flexiport-2.0.0-1.20111231git.
> fc17.x86_64.rpm

This is not a SOURCE rpm.
Comment 2 Rich Mattes 2012-06-30 14:54:03 EDT
Whoops! Sorry about that.

SRPM is at http://rmattes.fedorapeople.org/RPMS/flexiport/flexiport-2.0.0-1.20111231git.fc17.src.rpm
Comment 3 Dan Callaghan 2012-07-01 01:07:04 EDT
This SRPM fails to build. Looks like it needs

BuildRequires: cmake
BuildRequires: doxygen
BuildRequires: graphviz

You can try building your SRPM with mock (or a scratch build in Koji) to catch these problems.

A couple of other issues which also need fixing...

Your instructions for building the source tarball aren't quite right. Presumably you meant something like this:

# git clone git://github.com/gbiggs/flexiport.git ; cd flexiport
# git archive 1b6103daa | bzip2 >flexiport-2.0.0.tar.bz2

which worked for me and produced a tarball matching the one you have.

I'd strongly recommend you use GitHub's tarball generation feature instead, since it gives a usable source URL. See here:

http://lists.fedoraproject.org/pipermail/devel/2012-April/166267.html

You should also add %{?_isa} to the Requires for the -devel subpackage to make it arch-specific:

https://fedoraproject.org/wiki/Packaging/Guidelines#Requiring_Base_Package

Please send your gcc47.patch upstream and add a link to the upstream report in the .spec.

I would also suggest adding a comment above this line explaining its reason:

sed -i 's/extensions/#extensions/' doc/conf.py.in
Comment 4 Rich Mattes 2012-07-01 19:31:31 EDT
Thanks for having a look.  I've fixed the issues you pointed out, and submitted the gcc-4.7 patch upstream.  The new package can be found at:

Spec URL: http://rmattes.fedorapeople.org/RPMS/flexiport/flexiport.spec
SRPM URL: http://rmattes.fedorapeople.org/RPMS/flexiport/flexiport-2.0.0-2.20120701git1b6103d.fc17.src.rpm

rpmlint:
$ rpmlint flexiport.spec ../RPMS/x86_64/flexiport-*
3 packages and 1 specfiles checked; 0 errors, 0 warnings.

scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=4211477
Comment 5 Dan Callaghan 2012-07-02 00:16:08 EDT
Nice work Rich! This package is APPROVED.


Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== C/C++ ====
[x]: MUST Header files in -devel subpackage, if present.
[x]: MUST ldconfig called in %post and %postun if required.
[x]: MUST Package does not contain any libtool archives (.la)
[x]: MUST Package does not contain kernel modules.
[x]: MUST Package contains no static executables.
[x]: MUST Rpath absent or only used for internal libs.
[x]: MUST Package is not relocatable.
[x]: MUST Development (unversioned) .so files in -devel subpackage, if
     present.


==== Generic ====
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[x]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[x]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[x]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean would be needed if support for EPEL is required
[x]: MUST Sources contain only permissible code or content.
[x]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: Note: defattr macros not found. They would be needed for EPEL5
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[x]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Fully versioned dependency in subpackages, if present.
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[x]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf would be needed if support for EPEL5 is required
[-]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[x]: MUST License field in the package spec file matches the actual license.
The package declares itself to be under LGPLv3, although the file headers all state LGPLv2.1 or later. I think that's fine...
[x]: MUST License file installed when any subpackage combination is installed.
[x]: MUST Package consistently uses macros (instead of hard-coded directory
     names).
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST Package does not generate any conflict.
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[x]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[-]: MUST Package requires pkgconfig, if .pc files are present. (EPEL5)
[x]: MUST Requires correct, justified where necessary.
[x]: MUST Rpmlint output is silent.

rpmlint flexiport-2.0.0-2.20120701git1b6103d.fc17.x86_64.rpm

1 packages and 0 specfiles checked; 0 errors, 0 warnings.


rpmlint flexiport-devel-2.0.0-2.20120701git1b6103d.fc17.x86_64.rpm

1 packages and 0 specfiles checked; 0 errors, 0 warnings.


rpmlint flexiport-debuginfo-2.0.0-2.20120701git1b6103d.fc17.x86_64.rpm

1 packages and 0 specfiles checked; 0 errors, 0 warnings.


rpmlint flexiport-2.0.0-2.20120701git1b6103d.fc17.src.rpm

1 packages and 0 specfiles checked; 0 errors, 0 warnings.


[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
/home/dan/fedora/reviews/flexiport/take2/gbiggs-flexiport-1b6103d.tar.gz :
  MD5SUM this package     : ff65364d307c286be7562ef6b05b5c42
  MD5SUM upstream package : ff65364d307c286be7562ef6b05b5c42

[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: MUST Package contains a SysV-style init script if in need of one.
[x]: MUST File names are valid UTF-8.
[x]: MUST Useful -debuginfo package or justification otherwise.
[x]: SHOULD Reviewer should test that the package builds in mock.
[-]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[?]: SHOULD Package functions as described.
Not evaluated as it is a new library.
[x]: SHOULD Latest version is packaged.
[x]: SHOULD Package does not include license text files separate from
     upstream.
[x]: SHOULD Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: SHOULD The placement of pkgconfig(.pc) files are correct.
[x]: SHOULD Scriptlets must be sane, if used.
[x]: SHOULD SourceX / PatchY prefixed with %{name}.
     Note: Source0:
     https://github.com/gbiggs/%{name}/tarball/1b6103da/gbiggs-%{name}-%{gitrev}.tar.gz
     (gbiggs-%{name}-%{gitrev}.tar.gz) Patch0: flexiport-2.0.0-gcc47.patch
     (flexiport-2.0.0-gcc47.patch)
These are fine.
[x]: SHOULD SourceX is a working URL.
[-]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[-]: SHOULD %check is present and all tests pass.
No upstream test suite.
[-]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.


Generated by fedora-review 0.1.3
External plugins:
Comment 6 Rich Mattes 2012-07-07 10:36:58 EDT
Thanks for the review!
Comment 7 Rich Mattes 2012-07-07 10:37:42 EDT
New Package SCM Request
=======================
Package Name: flexiport
Short Description: Flexible communications library
Owners: rmattes
Branches: f16 f17 el6
InitialCC:
Comment 8 Gwyn Ciesla 2012-07-07 11:46:02 EDT
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.